# Slige

> slig *adjektiv*
>
> af en sådan art eller beskaffenhed som lige er eller vil blive antydet, nævnt eller omtalt ofte om noget foragtet eller ubehageligt[^[1]](<https://ordnet.dk/ddo/ordbog?query=slige&tab=for>)

A tool for developing high quality software.

Project includes: the slige-programming language, a compiler for slige, a runtime environment, a graphical fontend for code analysis

## Devtool

### Source code viewer

View program source code with syntax highlighting.

![](docs/source_code_page.png)

### Code coverage

View what parts of the program are executed what amount of times.

Includes 2 modes:
- **Performance view**: Used to locate *hot* sections in the program. The more *hot*, ie. the more times a section is executed, the more critical the section is for overall performance.
- **Test view**: Used to locate sections, that are not covered by tests. Automated tests are ineffective, if sections of the tested code, are not covered, ie. are never executed.

![](docs/code_coverage_page_test_view.png)

![](docs/code_coverage_tooltip_1.png)

![](docs/code_coverage_tooltip_2.png)

### Flame graph

A flame graph displays what functions' individual execution time make up the overall execution time.

![](docs/flame_graph_page.png)

![](docs/flame_graph_tooltip.png)


